.setcpu "65816"
.autoimport on
.include "inc/common-macros.inc"
.include "inc/GlobalVars.inc"
.include "inc/resource-macros.inc"
.include "inc/ports.inc"

.include "inc/pad-bits.inc"



.import Field1MapData:far

.export MapLoad
;.export MapLoadExtRomInVma_Base:far


.define  MONITOR_OFFSET7or8        7



;
;



; A16, I16
;    MAP_FIELD_NO          : X W
;    MAP_FIELD_GROBALX     : Y W
;    MAP_FIELD_GROBALY     : }bvԍ?
.proc MapLoad
.a16
.i16
	save_paxy


	; VBLank |C^Ǝɐݒ
	lda #.LOWORD(VBlank_MapLoad)
	sta VBLANK_POINTER

	set_a8
.a8
	lda #.LOBYTE(.HIWORD(VBlank_MapLoad))
	;lda #$80
.a16
	sta VBLANK_POINTER+2
	set_a16


;       TileMap̍ 
;       tilemap(0,0)
;       [h}bvł x-16,y-16
;		+-------------------------------------------------------------+
;		+                                                             +
;		+                                                             +
;		+         erʏ̍                                  +
;		+                                                             +
;		+          +-------------------------------------+            +
;		+          +                                     +            +
;		+          +                                     +            +
;		+          +         [h}bv            +            +
;		+          +           ̈ʒu                +            +
;		+          +             (x,y)                   +            +
;		+          +              x,y                    +            +
;		+          +                                     +            +
;		+          +         XN[WX^          +            +
;		+          +           ̏ʒu                +            +
;		+          +           16*15+8,16*15+8           +            +
;		+          +                                     +            +
;		+          +                                     +            +
;		+          +                                     +            +
;		+          +-------------------------------------+            +
;		+                                                             +
;		+                                                             +
;		+-------------------------------------------------------------+

		; 1HBLANK4word ށB
		;  300 * HBLANK = 1200
		;  VBLANK 2񂮂炢œ]͏I͂H
		
		; HBLANK 4[hƂɏރpPbghCoH
		; pӂāA
		; MainLoop łS[hƂɗpӂhCoHp


	jsr MapSetup



	bra r_wait



	MapLoad_MainLoop:
		; VBlank荞ݔɎs
		; C[v
		;jsr MapUpdateScene
		stz gRenderFinished


			r_wait:

				; VBlankN܂ł̑ҋ@[v
				lda MAP_SDMA_READY
				bne :+
				jsr MapSetTileData
				bra VBlankWait

				:
				jsr MapVramWrite

				VBlankWait:
				lda gRenderFinished
				beq r_wait

		lda MAP_MAPADDR_READY
		cmp #5
		beq MapLoad_Done

	bra MapLoad_MainLoop



	MapLoad_Done:

	restore_paxy
	rts
.endproc







; A16, I16
; NMI 荞
.proc VBlank_MapLoad
.a16
.i16

.if 0

set_a8
.a8

	;phb
	;lda #$0		; DataBank WX^0ɐݒ肵
	;pha
	;plb

	; BG0 XN[WX^0X ɏ
	lda gScrollX
	sta pScrollX0
	lda gScrollX+1
	sta pScrollX0

	; BG0 XN[WX^0Y ɏ
	lda gScrollY
	sta pScrollY0
	lda gScrollY+1
	sta pScrollY0
set_a16
.a16

.endif

	inc gRenderFinished

	;pld
	;plb	; DataBank WX^𕜋

	pla ; A16bitŕA
	plp ; 荞ݑOP𕜋A
	rti
.endproc







; A16, I16
.proc MapSetup
.a16
.i16
	save_paxy

	; tB[hꗗ̔z񂩂tB[hNo X̃AhXATCY擾
	lda MAP_FIELD_NO
	asl a
	asl a
	asl a
	tax
	lda FIELDNO_ADDRS, x
	sta MAP_FIELD_TOPADDR
	lda FIELDNO_ADDRS+2, x
	sta MAP_FIELD_TOPADDR+2


	lda MAP_FIELD_NO
	tax
	lda FIELDNO_WDITHS,x
	sta MAP_FIELD_WIDTH

	lda MAP_FIELD_NO
	asl a
	tax
	lda FIELDNO_HEIGHTS,x
	sta MAP_FIELD_HEIGHT



	stz MAP_CURRENTBLOCK_HCNT
	stz MAP_CURRENTBLOCK_VCNT


	lda MAP_FIELD_TOPADDR
	sta MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB2
	sta MAP_FIELD_ADDR_MAPB3

	lda MAP_FIELD_TOPADDR+2
	sta MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB2+2
	sta MAP_FIELD_ADDR_MAPB3+2

	stz MAP_SDMA_READY


	; 4	Xe[g̃AhX݊֐̃e[u쐬
	; MAP_SDMA_READY=0? jmp XX
	; MAP_SDMA_READY=1? jmp XX
	; .....cmp ߂炸珑̂ȂEEEӖȍ
	lda MAP_FIELD_WIDTH
	asl a
	asl a
	asl a
	tax
	ldy #4

	:
	lda MAKEADDR_WIDTHX_POINTERS,x
	sta MAP_POINTER_MAKEADDRS,x
	inx
	inx
	dey
	bne :-

	stz MAP_MAPADDR_READY

	; VMA sɂoN؂ւǂݍ݂
	; s֐RAMɓWJB
	; RAM̖ߒlύX 24bitǂݍ݂sB
	ldx #0
	ldy #12
	set_a8
	TransferVmaFunc_loop:
	lda MapLoadExtRomInVma_Base,x
	sta MAP_LOADEXTROM_VMAFUNC,x
	inx
	dey
	bne TransferVmaFunc_loop

.if 0
	; ǂݍ݂AhXʂZbg
	ldx #0
	;set_a8
	;.a8
	;.i8
	set_a16
	.a16
	.i16
	lda #12
	sta MAP_LOADEXTROM_VMAFUNC+1		; ǂ߂̂ȁH

	set_a8
	.a8
	lda #0
	sta MAP_LOADEXTROM_VMAFUNC+3

	; VMA s֐̃eXgĂяo
	jsl f:MAP_LOADEXTROM_VMAFUNC
	nop

.endif

	set_a16

	stz MAP_SDMA_MODE
	stz MAP_SDMA_IGNORE_VCOUNTER_CNT

	restore_paxy
	rts
.endproc







; A16, I16
.proc MapSetTileData
.a16
.i16
	save_paxy

	; B0-B3܂ł̃AhX쐬
	lda MAP_MAPADDR_READY
	cmp #4
	bpl MAPLOAD_START

	; ɃWv悪64KBȓɂ͎܂ƎvǁEEEB
	; ʖڂ璼ڃ|C^蒼ȂB
	 asl a
	 tax
	 jmp (MAP_POINTER_MAKEADDRS,X)


		; addr = Base + ( X - 16 + POS  ) *2 + width * ( VCNT  + Y - 16 )
		;
		;
		; width 256Ƃ̋ElɂƂ΃AhXvZ͂ȂɂǂȂH
		; width :32(0x20)tile   2 ʕ    1Map Ȃ@VCNT+1ɂ AhX + 0x40(1tile1word)
		;         64(0x40)       4          2Map Ȃ                        + 0x80
		;        256(0x100)     16          8Map Ȃ                        + 0x200
		;        512(0x200)     32         16Map Ȃ                        + 0x400
		;       1024(0x400)     64         32Map Ȃ                        + 0x800                   v1MB
		;       2048(0x800)    128         64Map Ȃ                        + 0x1000 0x40 0000oCgA4MB
		;       4096(0x1000)   256        128Map Ȃ                        + 0x2000 0x100 0000oCgA16MB(ނ肗)
		
		; }bv32x32tile ƂɃ}bvԍUR[h͊yɂȂ邩H
		; map0:0       0x1f .....           map255   0xfc00   fc1f
		;      .....                                 ....
		;      0x3e0  0x3ff                          0xffe0  0xffff
		;
		;  VCNT 邽тɁA茅ω̂ŕ₷ᕪ₷ȁcB
		;
		;map
		;
		; O[oX = 32 * X}bvNo + tB[h[JX
		;           y        y                             y
		;
		;
		;
		;  X}bvNo : 0-128?
		;  X}bvNo= O[oX >> 5
		;  y                    y
		;
		; xxxx xxxx   yyyy yyyy  ܂Vtg킴킴ȂĂB
		;
		;  lsr a
		;  lsr a
		;  lsr a
		;  lsr a
		;  lsr a
		;  and #$7ff
		;
		;
		;  tB[h}bv̐擪AhX
		;   = X}bvNo *32 + Y}bvNo * (tB[h*32 )
		;                     |C^Ŋ֐ĂяoyH
		;
		;   Y x ... ͔zŁuvZv
		;   32 x ... B
		;
		; HA擪AhXuvZv̂CȂB
		;   u悤B
		;
		; ׂ̃}bvƔ̂Ȃ񂾂ȁB
		; őłS̃}bv܂BS̃AhX̓ɒuĂ΂B
		; HBLANK Pɂ1AhX悤ɂāc
		; E̍ۂɂ̓AhXPAvQB
		;          +-----------------------------------+
		;          |B0              |B1                |
		;          |                |                  |
		;          |                |                  |
		;          |      +----------------+           |
		;          |      |                |           |
		;          |      |    +-----+     |           |
		;          |      |    |     |     |           |
		;          |B2    |    |     |     |           |
		;          |------|    +-----+     |-----------|
		;          |      |          B3    |           |
		;          |      +----------------+           |
		;          |                |                  |
		;          |                |                  |
		;          |                |                  |
		;          |                |                  |
		;          +-----------------------------------+
		
		;
		; AhXAŏłPȂ񂾂ǁcB
		; P: tB[h[JX=0 tB[h[JY=0
		; Q: tB[h[JX  tB[h[JY 0 ȊO
		; S: Ƃ 0 ȊO
		; 
		;
		; VRAM[JX,Y ͏ɃXN[WX^ (VRAM[JX-8)*16 +8 ɂȂH
		; VRAM̐擪F O[oX - 8(j^ʒ獶[܂ł̃ItZbg) - 8(j^ʂVRAM̒ɗ悤)    - }bvX NO*32 (tile)
		;
		; }bv[h
		; VRAM[JX ͏7or8ɂȂȂ΂ȂȂA͂B
		; XN[͂VRAM[JX/Y͏dvł͖Ă
		;
		; } B0AVRAM擪ɗuǂݍݍŐ擪Ԓnv
		;     (tB[h}bv̐擪AhX)
		;          = X}bvNo *32 + Y}bvNo * (tB[h*32 )
		;     +   O[oX  - X}bvNo *32 - 16 - 7or8
		;     + ( O[oY  - Y}bvNo *32 - 16 - 7or8 ) * 32
		;





		; lda (dp),Y
		; lda ($2,S),Y
		; ߎgďȑfōĐ݌vB
		; dp ɃtB[h̃gbvAhXĂāA
		; Y <= 0x-0xffff 65535 ܂œ邩B
		; 0xffe0  111 1111 0x7f, 128 ܂ňHHH
		; O[oX, O[oY ācB

		;  񂾂4096ƂƃI[o[t[邩B
		;  tB[h̃gbvAhX𒲐B

		; (dp),Y     DP Indirect Indexed, Y
		;
		;            DBR :  DP+DPoffset     ɏĂAhX
		;              Y REG 𑫂lǂݍ
		;
		; lda
		; (sr,S),Y   SR Indirect Indexed,Y
		;            DBR: [X^bN+sr8bitl]Ԓn16bit̒l  + Y Ԓnǂݍ

		; lda [d]    Direct indirect Long-[d]
		;			 00 : DirectRegister 16bit l + d(8bitl)
		;			 ɏĂAhXf[^ǂݍށAƂ
		;			炵B
		;
		; lda (d)   Direct Indirect-(d)
		;			 DBR : DirectRegister 16bit l + d(8bitl)
		;			 ɏĂAhXf[^ǂݍށAƂ
		;			炵B
		;
		;
		; lda a:Sym,y   DBR:Syml(16bit) + y ԒnǂݍށA
		;				ƂӖ炵B
		;
		; lda a:Sym     DBR:Syml(16bit)     ԒnǂݍށA
		;				ƂӖ炵B
		;
		;     z:Sym  DirectRegisteer + offset(8bit) 



		; ́AItZbgAhX ffff 𒴂P[XB
		; MAP_YNO 128 𒴂P[X͕ʓrR[hKvɂȂAƁB

		; MAP NO  256 ǂ납1024 炢܂ŎgzIł
		; 邪Bm MAP_Y_NO  256܂łƂ̂̓CpNgCB
		; ۂɂ256}bv̉opӏoȂƂ͂邪
		;
		; 4096 }bv0x1000B  ɑ΂0-4095(0x1000 )
		; ƁAő 0x100 0000
		; 16MBɂȂBۂɂ͂ȃf[^A4MBROMɓȂcB
		; RAMŏKv󂾂ȁB
		;
		; RAM ɃtB[h}bv𓀂
		; QƂ鏈̂ɂȂH
		;
		;
		; ƂẮA128MAP, 256ʁA128(0x80)*32(0x20)=4096, 0x1000`bv܂
		; Ƃ肠銴B
		;
		;
		; lda (dp),Y ߂ƃItZbg 0x10000܂Ŏw\cB
		; 
		; RAM lda ߎĂāAdp̃ItZbg𒼐ڃvOI
		;EEEӖȂf[^oNWX^삷󂶂ȂB
		;


		; MAP_XNO_32 = O[o X -8 - Monitor7or8 &0xffe0
		; if MAP_XNO_32 > ((width/32 )<<5) then MAP_XNO_32 <=  MAP_XNO_32 -  ((width/32 )<<5)
		; if MAP_XNO_32 < 0 then MAP_XNO_32 <=  MAP_XNO_32 + ((width/32) << 5)
		; y ɂ
		;  MAP_YNO <= MAP_YNO_32 >> 5
		;
		;
		;  @ tB[hItZbgB0 MAP_YNOItZbg+0(16bit) =
		;                                      widthƂ̃ItZbge[uQƂ
		;                                      YAzԍMAP_YNO
		;  AtB[hItZbgB0 MAP_YNOItZbg+2(8bit) =
		;                                      widthƂ̃ItZbge[uQƂ
		;                                      YAzԍMAP_YNO
		;
		;
		;  z͂ȊH
		;   width_for4096x4096 = (0,0)
		;                                    (width=4096,0x1000)
		;                        1(MAP_YNO) * 0x1000 * 0x20  >>16,         1(MAP_YNO) * 0x1000 * 0x20 & 0xffff
		;
		;
		;   tB[hItZbgB0 +0(16bit)   
		;                                @
		;                               + ( MAP_XNO_32 ) << 5
		;
		;   tB[hItZbgB0 +2(8bit)    A  + ̃LB
		;
		;
		;
		; B0͊B
		;
		; B1:			MAP_XNO_32 <= MAP_XNO_32 + 0x20         1ubNEɂ炷
		;				if MAP_XNO_32 >  (wdith/32) << 5 		XŏIubN𒴂
		;			B1+2 <= B0+2  -  (width/32 ) * 0x400
		;			B1   <= B0+0   - L̃LBЂ

		; ₱EEEEB


	MAPLOAD_START:
		cmp #5
		bne :+
		; MAP_MAPADDR_READY=5(Sē])Ȃ牽Ȃ
		brl MapSetTileData_TransferAllDone
	
		:
		lda MAP_CURRENTBLOCK_ADDR
		sta MAP_CURRENTADDR
		lda MAP_CURRENTBLOCK_ADDR+2
		set_a8
		sta MAP_CURRENTADDR_DB
		set_a16

		;  X_POS + y_Pos x 0x400 vZ
		lda MAP_Y_POS
		asl
		tax
		lda MAP_CALC_YPOS,x
		add MAP_X_POS

		

		; oNȂĖőɂ󂶂ȂǁA
		; ÔߑĂB
		adc MAP_CURRENTADDR
		sta MAP_CURRENTADDR
		bcc VmaFunc_NoBankAdd
		set_a8
		inc MAP_CURRENTADDR_DB
		set_a16
		VmaFunc_NoBankAdd:

		

		; cAނvZ
		; CurBlock 0 or 2 Ȃ: 32 -POS
		; Curblock 1 or 3 Ȃ: 32-HCNT
		
		lda MAP_CURRENTBLOCK
		and #$1
		bne UseCount_CurBlock_1_3
		; & 1  = 0   : CurBlock = 0or2
		lda #32
		sub MAP_X_POS_STA
		bra WriteCount_Got
		
		UseCount_CurBlock_1_3:
		lda #32
		sbc MAP_CURRENTBLOCK_HCNT
		
		WriteCount_Got:
		tay	; ݃JE^Yɓ
		sta MAP_LOADEXTROM_DATASIZE


		; ݒɃoN؂ւ
		; ̂Ȃʃ[`ŏ
		pha
		lda MAP_CURRENTADDR
		adc 0,S
		pla
		bcc NoBankUp
			
			; oNpRomǂݍ݊֐gp
			jsr Map_LoadRomAclossDataBank
			bra VmaRomLoad_Done
		
		NoBankUp:


		; VMA s֐Ăяo
		set_a8
		ldx #0
		jsl f:MAP_LOADEXTROM_VMAFUNC
		set_a16

		VmaRomLoad_Done:

		; ǂݍ񂾕HCNT炷
		lda MAP_LOADEXTROM_DATASIZE
		add MAP_X_POS
		sta MAP_X_POS
		
		lda MAP_CURRENTBLOCK_HCNT
		sub MAP_LOADEXTROM_DATASIZE
		sta MAP_CURRENTBLOCK_HCNT


		; PDHCNT=32                          ܂œǂݍ񂾏ꍇ
		;     ( B0,Pos_sta=0   B1, POS=0 )
		; QDPOS>0   POS=31               ܂œǂݍ񂾏ꍇ
		;		Bank 1or3 
		

		lda MAP_CURRENTBLOCK_HCNT
		cmp #32
		bpl TryVCntPlus

		; QDPOS>0   POS=31               ܂œǂݍ񂾏ꍇ
		; Bank1 or 3 ɁB
		stz MAP_X_POS
		inc MAP_CURRENTBLOCK
		lda MAP_CURRENTBLOCK
		asl a
		asl a
		tax
		lda MAP_FIELD_ADDR_MAPB1,x
		sta MAP_CURRENTBLOCK_ADDR
		lda MAP_FIELD_ADDR_MAPB1+2,x
		set_a8
		sta MAP_CURRENTADDR_DB
		set_a16

		; ׂɃOWvȂĂȂB
		bra SDMA_SET		; SDMA Zbg



		TryVCntPlus:
		; cRQCI
		inc MAP_CURRENTBLOCK_VCNT
		cmp #32
		bne NextVCnt
		
		lda #5
		sta MAP_SDMA_READY

		bra SDMA_SET


		NextVCnt:
		stz MAP_CURRENTBLOCK_HCNT
		lda MAP_X_POS_STA
		sta MAP_X_POS

		ldx #0
		inc MAP_Y_POS
		lda MAP_Y_POS
		cmp #32
		bne ToBank0or2
		
		
		;Bank1
		stz MAP_Y_POS
		
		lda #1
		sta MAP_CURRENTBLOCK

		lda MAP_FIELD_ADDR_MAPB1
		sta MAP_CURRENTBLOCK_ADDR
		lda MAP_FIELD_ADDR_MAPB1+2
		set_a8
		sta MAP_CURRENTADDR_DB
		set_a16

		bra SDMA_SET

	ToBank0or2:

		;Bank0or2
		stz MAP_Y_POS
		
		lda MAP_CURRENTBLOCK
		cmp #3
		bne :+
		; CurBank=1, TO bank0
		lda #0
		sta MAP_CURRENTBLOCK
		tax
		bra Set_Bank0or2
		:
		; CurBank=3, TO bank2
		lda #2
		sta MAP_CURRENTBLOCK
		ldx #2*2
		
		
		Set_Bank0or2:
		lda MAP_FIELD_ADDR_MAPB0,x
		sta MAP_CURRENTBLOCK_ADDR
		lda MAP_FIELD_ADDR_MAPB2+2,x
		set_a8
		sta MAP_CURRENTADDR_DB
		set_a16

		;bra SDMA_SET


	SDMA_SET:


	; SDMA ǂݎJnʒuZbg
	stz MAP_LOADEXTROM_NEXTDATAPOS

	inc MAP_SDMA_READY

	MapSetTileData_TransferAllDone:

	restore_paxy
	rts
.endproc




; A16, I16
; }bvAhXASZbg
.proc MapLoadExtRomInVma_Base
.a16
.i16

	loop:
	lda f:$012345,x
	sta MAP_LOADEXTROM_DATAS, x
	inx
	dey
	bne loop
	rtl


	;lda f:$012345,x
	
	;rtl

;               ; }bvAhXASZbg
;               .proc MapLoadExtRomInVma_Base
;               .a16
;               .i16
;  BF 45 23 01  	lda f:$012345,x
;  6B           	rtl
;               .endproc

	; oN̏ꍇ͏s\ȓ_ɒӁB

.endproc



; A16, I16
; f[^oNRomǂݍގvmas֐
; y : ݉
.proc Map_LoadRomAclossDataBank
.a16
.i16

	; VMAss߂
	; lda f:sym,x  lda f:sym 
	.a8
	set_a8
	lda #$af
	sta MAP_LOADEXTROM_VMAFUNC
	lda #$6b
	sta MAP_LOADEXTROM_VMAFUNC+5


	;.a16
	;set_a16
	
	;set_a8
	ldx #0
	loop:
	jsl f:MAP_LOADEXTROM_VMAFUNC
	sta MAP_LOADEXTROM_DATAS, x
	
	set_a16
	inc MAP_CURRENTADDR
	set_a8
	bcc :+
	inc MAP_CURRENTADDR_DB
	
	:
	
	inx
	dey
	bne loop
	set_a16
	
	; VMAss߂̂ɖ߂
	.a8
	set_a8
	lda #$bf
	sta MAP_LOADEXTROM_VMAFUNC
	lda #$e8
	sta MAP_LOADEXTROM_VMAFUNC+5

	.a16
	set_a16


	rts
.endproc










; A16, I16
; VRAMRomǂݎf[^]
.proc MapVramWrite
.a16
.i16
	save_paxy

	;ǂȊɂEEEB
	; Ƃ肠eLg[ɂ
	lda MAP_SDMA_MODE
	asl
	tax
	jsr (SDMAFUNC_POINTERS,x)

	restore_paxy
	rts
.endproc











; A16, I16
; VRAMVRAM݃AhXA퓬Ԓn
.proc MapVramWrite_WriteVmaAddr
.a16
.i16

	jsr MapVramWrite_WaitHblankInt
	beq WriteVmaAddr_Exit

	lda kMap1StartW_2			; VRAM ݔԒn擪 0x6000 錾
	sta pVWriteAddrW
	inc MAP_SDMA_MODE

WriteVmaAddr_Exit:
	rts
.endproc




; A16, I16
; VRAMVRAM݃AhXA퓬Ԓn
; return A:0   VRAM ݂łȂ
;        A:1                ł
.proc MapVramWrite_WaitHblankInt
.a16
.i16
	mEnableHighClockMode

	; VBlank 荞݂߂牽Ȃׂ̃WvB
	lda		MAP_SDMA_IGNORE_VCOUNTER_CNT
	beq		CheckVCounter
	
	dec		MAP_SDMA_IGNORE_VCOUNTER_CNT
	bra 	WaitHblankInt_Exit

	CheckVCounter:
	.a8
	set_a8
	; uo̓|[g̐MςāAVCounter,HCounter 
	; b`
	lda #$80
	sta $4201
	lda #$00
	sta $4201
	
	.a16
	set_a16

	; VCounter ǂݍ
	lda $213d
	and #$01ff
	cmp		#224
	bpl		CheckHCounter
	; 128 [v炢͓KɖB
	lda		#$10
	sta		gIGNORE_VHCOUNTER_CNT
	bra 	WaitHblankInt_Exit

	CheckHCounter:

	; HCounter ǂݍ
	lda $213c
	and #$01ff
	cmp		#(274-15)				; 5?12?   0x103   3A
	;bmi 	WaitHblankInt_Exit		; 5?12?
	bmi		CheckVCounter

	cmp		#(339-3-9-10)			; 5?12?   0x13d
	;bpl 	WaitHblankInt_Exit		; 5?12?
	bpl		CheckVCounter

	lda #1
	rts

WaitHblankInt_Exit:
	lda #0

	rts
.endproc








; A16, I16
; VRAMARomkǂݎf[^]
.proc MapVramWrite_WriteRomRawDatas
.a16
.i16

	;ldx MAP_SDMA_DATALASTPOS

	; HBlank҂
	jsr MapVramWrite_WaitHblankInt
	beq WriteRomRawDatas_Exit

	; 8[v͉\?
	lp:
		lda MAP_LOADEXTROM_DATAS,x		; 6 cycle
		sta pVWriteValW					; 5 cycle

		dexdex							; 2+2 cycle
		bne lp							; 3 cycle


	dec MAP_SDMA_MODE

	lda MAP_LOADEXTROM_NEXTDATAPOS
	cmp MAP_LOADEXTROM_DATASIZE
	bmi WriteRomRawDatas_Exit

	stz MAP_SDMA_READY

WriteRomRawDatas_Exit:


	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_32x32
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy


	; B0-3 <= MAP0
.if 0
	lda MAP_FIELD_TOPADDR
	sta MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB2
	sta MAP_FIELD_ADDR_MAPB3

	lda MAP_FIELD_TOPADDR+2
	sta MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB2+2
	sta MAP_FIELD_ADDR_MAPB3+2
.endif

	; MAP_X_MAPNO <= 0
	stz MAP_X_MAPNO_32
	stz MAP_Y_MAPNO

	;-------------------------------------------------------
	;--------- MAP_X_POS_STA, MAP_X/Y_POS ̐ݒ -----------
	;-------------------------------------------------------
	; MAP_X_POS_STA <= MAP_FIELD_GROBALX - MONITOR_OFFSET7or8
	; If MAP_X_POS_STA <0 then MAP_X_POS_STA <= MAP_X_POS_STA + 32
	; MAP_X_POS_STA <= MAP_X_POS_STA & 0x1f

	lda MAP_FIELD_GROBALX
	sub MONITOR_OFFSET7or8
	bpl SET_X_POS_STA
	add #32

SET_X_POS_STA:
	and #$1f
	sta MAP_X_POS_STA
	sta MAP_X_POS

	; MAP_Y_POS_STA ɂĂ
	lda MAP_FIELD_GROBALY
	sub MONITOR_OFFSET7or8
	bpl SET_Y_POS_STA
	add #32

SET_Y_POS_STA:
	; y pos sta ͂Ȃ񂶂c
	;sta MAP_Y_POS_STA
	and #$1f
	sta MAP_Y_POS

	stz MAP_CURRENTBLOCK
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_CURRENTBLOCK_ADDR
	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_CURRENTBLOCK_ADDR+2


	lda #4
	sta MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc


; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_64x64_State0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy


	; MAP_MAPADDR_READY 0 : B0,1 ݒ
	; B0 <= MAP0, B1 <= MAP1
	lda MAP_FIELD_ADDR_MAPB0
	add #$400		; MAP1 offset 32x32
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	inc MAP_FIELD_ADDR_MAPB1+2

	:


	lda MAP_FIELD_GROBALX+2
	; GrobalX > 32+8+7or8 or GrobalX < 8 + 7or8
	; then B0  <= MAP1   , B1 <= MAP0
	; else B0  <= MAP0   , B1 <= MAP1
	cmp #(32+8+MONITOR_OFFSET7or8 )
	bpl B01_SWAP
	cmp #(8+MONITOR_OFFSET7or8 )
	bmi B01_SWAP


	bra B01_SETTED

B01_SWAP:

	; B0B1 ւ
	ldx MAP_FIELD_ADDR_MAPB0
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB0
	stx MAP_FIELD_ADDR_MAPB1

	ldx MAP_FIELD_ADDR_MAPB0+2
	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB0+2
	stx MAP_FIELD_ADDR_MAPB1+2


B01_SETTED:
	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc



; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_64x64_State1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B2<=B0+0x800
	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2

	lda MAP_FIELD_ADDR_MAPB0
	add #$800		; MAP2 offset 32x32 x2
	sta MAP_FIELD_ADDR_MAPB2
	bcc :+
	inc MAP_FIELD_ADDR_MAPB2+2
	:

	; B3<=B1+0x800
	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2

	lda MAP_FIELD_ADDR_MAPB1
	add #$800		; MAP3 offset 32x32 x2
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	inc MAP_FIELD_ADDR_MAPB3+2
	:






	lda MAP_FIELD_GROBALY+2
	; GrobalY > 32+8+7or8 or GrobalY < 8 + 7or8
	; ȂAB01 B23 ւB
	cmp #(32+8+MONITOR_OFFSET7or8 )
	bpl B01_23_SWAP
	cmp #(8+MONITOR_OFFSET7or8 )
	bmi B01_23_SWAP


	bra B01_23_SETTED

B01_23_SWAP:

	; B0B2,B1B3ւ
	ldx MAP_FIELD_ADDR_MAPB0+2
	lda MAP_FIELD_ADDR_MAPB2+2
	sta MAP_FIELD_ADDR_MAPB0+2
	stx MAP_FIELD_ADDR_MAPB2+2

	ldx MAP_FIELD_ADDR_MAPB0
	lda MAP_FIELD_ADDR_MAPB2
	sta MAP_FIELD_ADDR_MAPB0
	stx MAP_FIELD_ADDR_MAPB2

	ldx MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB3+2
	sta MAP_FIELD_ADDR_MAPB1+2
	stx MAP_FIELD_ADDR_MAPB3+2

	ldx MAP_FIELD_ADDR_MAPB1
	lda MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB1
	stx MAP_FIELD_ADDR_MAPB3


B01_23_SETTED:
	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc


; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_64x64_State2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	;-------------------------------------------------------
	;--------- MAP_X_POS_STA, MAP_X/Y_POS ̐ݒ -----------
	;-------------------------------------------------------
	; MAP_X_POS_STA <= (MAP_FIELD_GROBALX - 8 - MONITOR_OFFSET7or8 ) & 0x1f
	; If MAP_X_POS_STA <0 then MAP_X_POS_STA <= MAP_X_POS_STA + 32
	; If MAP_X_POS_STA > 32 then MAP_X_POS_STA <= MAP_X_POS_STA - 32

	lda MAP_FIELD_GROBALX
	sub 8+MONITOR_OFFSET7or8
	bpl :+
	add #32

:	and #$1f

SET_X_POS_STA:
	sta MAP_X_POS_STA
	sta MAP_X_POS

	; MAP_Y_POS_STA ɂĂ
	lda MAP_FIELD_GROBALY
	sub 8+MONITOR_OFFSET7or8
	bpl :+
	add #32

:	and #$1f
SET_Y_POS_STA:
	;sta MAP_Y_POS_STA
	sta MAP_Y_POS

	stz MAP_CURRENTBLOCK
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_CURRENTBLOCK_ADDR
	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_CURRENTBLOCK_ADDR+2



	lda #4
	sta MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc









; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_128x128_state0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	;		0-31     32-63    64-95    96-127
	;		MAP00    MAP0 1   MAP02    MAP03
	;		MAP04    MAP0 5   MAP06    MAP07
	;		MAP08    MAP0 9   MAP0a    MAP0b
	;		MAP0c    MAP0 d   MAP0e    MAP0f


	; ȊȂcB
	;  Map XNo_32 <= (GrobalX - 8 - MONITOR_OFFSET7or8 )
	;  Map YNo <= (GrobalY - 8 - MONITOR_OFFSET7or8 ) >> 5

	; B0 = Base + Map XNo_32 *32
	;			+ Map YNo    * 32*32 * 4(  128/32 )

	lda MAP_FIELD_GROBALX
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((128/32 )<<5)
	bra :++

:	cmp #((128/32 )<<5)			; ЂƂ
	bmi :+
	sub #((128/32 )<<5)

:	and #$ffe0
	sta MAP_X_MAPNO_32


	lda MAP_FIELD_GROBALY
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((128/32 )<<5)
	bra :++

:	cmp #((128/32 )<<5)			; ЂƂ
	bmi :+
	sub #((128/32 )<<5)

	:
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	sta MAP_Y_MAPNO



	; B0  MAP_XNO * 0x400 ƂB
	; 0x0400*MapNo  : 0-3(MAX127), 0x0000-0x7f00
	lda MAP_X_MAPNO_32		; X}bvԍ߂
	lsr
	lsr
	lsr
	pha
	lsr
	lsr
	sta MAP_X_MAPNO
	pla
	;								 0x0-0x7f
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+
	inc MAP_FIELD_ADDR_MAPB0+2
:	
	; ܂ȁH 
	;inx
	;inx
	;lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	;add MAP_FIELD_ADDR_MAPB0+2

	;  X ItZbg̏͋ʉo񂾂ȁB



	; B0  MAP_YNO * 0x1000 ƂB
	; 0x1000*MapNo  : 0-31, 0x1000-0x1 f000
	lda MAP_Y_MAPNO
	asl a
	asl a
	tax
	; 128 ȍ~͂̔z񂪕ς邾Ȃ񂾂ȁcB
	lda MAP_CALC_MAP128x128_YNO,x			; Y_MAPNO * 0x1000 ̉ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+ 
	inc MAP_FIELD_ADDR_MAPB0+2			; オ蕪𑫂Ƃ
:

.if 0
	; YMAP_NO = MAX3 , YMAP_NO* 3(c}bvől) * 0x400 ő0x4000܂łȂ̂
	; 128x128tile Map ł͈ȉ͈ꉞȂB
	lda MAP_CALC_MAP128x128_YNO+2,x			; Y_MAPNO * 0x1000 ̏ʂ擾
	add MAP_FIELD_ADDR_MAPB0+2
.endif

	inc MAP_MAPADDR_READY



	restore_paxy
	rts
.endproc








; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_128x128_state1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1

	; B1  B0 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (128/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	;  .4096..... 8bit ZႱIȂ悤ȁcB
	lda MAP_FIELD_ADDR_MAPB1
	sub #(   ( $400 * ( 128/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	dec MAP_FIELD_ADDR_MAPB1+2

	:
.if 0
	; 128x128ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA1024^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda #(   ( $400 * ( 128/32 -1 ) ) >>16 )
	sub MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB1+2
.endif


B1_DONE:
	; B2  B0 ̉BEI[o[ȂԏɈړ

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB2

	lda MAP_Y_MAPNO
	add #1
	cmp #( 128/32 )
	bpl Y_TOTOP

	; }bvɈړlɕύX
	lda #($400 * 128/32 )
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B2_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B2_DONE

	Y_TOTOP:
	; }bvԏɈړlɕύX
	lda #(  (($400*128/32) * ( 128/32 -1 )) & $ffff )
	sub MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc Y_TOTOP_HIGHSUB
	dec MAP_FIELD_ADDR_MAPB1+2
Y_TOTOP_HIGHSUB:

	;܂B
	;lda #(  ($400*128/32) * ( 128/32 -1 ) >>16 )
	;sub MAP_FIELD_ADDR_MAPB1+2

B2_DONE:

	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc




; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_128x128_state2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B3  B1 ̉EBEI[o[ȂԍɈړ

	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB3

	; B3  B1 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (128/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB3+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda #(   ( $400 * ( 128/32 -1 ) ) & $ffff )
	sub MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	dec MAP_FIELD_ADDR_MAPB3+2

	:
	B1_DONE:
.if 0
	; 128x128ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA1024^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda #(   ( $400 * ( 128/32 -1 ) ) >>16 )
	sub MAP_FIELD_ADDR_MAPB3+2
	sta MAP_FIELD_ADDR_MAPB3+2
.endif



	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc







; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_256x256_state0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	;		0-31     32-63    64-95                             224-255
	;		MAP00    MAP01    MAP02 MAP03  MAP04   MAP05  MAP06  MAP07
	;		MAP08    MAP09    MAP0a  ....                        MAP0f
	;		             ......
	;		MAP78    MAP79    MAP7a  ....                        MAP7f


	; ȊȂcB
	; قƂ 128x128 Ɠ͂H
	;  Map XNo_32 <= (GrobalX - 8 - MONITOR_OFFSET7or8 )
	;  Map YNo <= (GrobalY - 8 - MONITOR_OFFSET7or8 ) >> 5

	; B0 = Base + Map XNo_32 *32
	;			+ Map YNo    * 32*32 * 8(  256/32 )

	lda MAP_FIELD_GROBALX
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((256/32 )<<5)
	bra :++

:	cmp #((256/32 )<<5)			; ЂƂ
	bmi :+
	sub #((256/32 )<<5)

:	and #$ffe0
	sta MAP_X_MAPNO_32


	lda MAP_FIELD_GROBALY
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((256/32 )<<5)
	bra :++

:	cmp #((256/32 )<<5)			; ЂƂ
	bmi :+
	sub #((256/32 )<<5)

	:
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	sta MAP_Y_MAPNO



	; B0  MAP_XNO * 0x400 ƂB
	; 0x0400*MapNo  : 0-7(MAX127), 0x0000-0x7f00
	lda MAP_X_MAPNO_32		; X}bvԍ߂
	lsr
	lsr
	lsr
	pha
	lsr
	lsr
	sta MAP_X_MAPNO
	pla
	;								 0x0-0x7f
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+
	inc MAP_FIELD_ADDR_MAPB0+2
:
	; 8 x 0x400=0x2000 ʂ͌vZςݐl͐΃[ɂȂB
	; ̂ŃRgAEgƂ肠ƂB
	;inx
	;inx
	;lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	;add MAP_FIELD_ADDR_MAPB0+2




	; B0  MAP_YNO * 0x2000 ƂB
	; 0x2000*MapNo  : 0-7(max 7f), 0x2000-0x1 0000
	lda MAP_Y_MAPNO
	asl a
	asl a
	tax
	; 128 ȍ~͂̔z񂪕ς邾Ȃ񂾂ȁcB
	lda MAP_CALC_MAP256x256_YNO,x			; Y_MAPNO * 0x2000 ̉ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	bcc :+ 
	inc MAP_FIELD_ADDR_MAPB0+2			; オ蕪𑫂Ƃ
:

.if 0
	; YMAP_NO = MAX3 , YMAP_NO* 7(c}bvől) * 0x400 ő0xe000܂łȂ̂
	; 2568x256tile Map ł͈ȉ͈ꉞȂB
	lda MAP_CALC_MAP256x256_YNO+2,x			; Y_MAPNO * 0x2000 ̏ʂ擾
	add MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB0+2
.endif

	inc MAP_MAPADDR_READY



	restore_paxy
	rts
.endproc







; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_256x256_state1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1

	; B1  B0 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (256/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB1
	sub #(   ( $400 * ( 256/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	dec MAP_FIELD_ADDR_MAPB1+2

	:
.if 0
	; 256x256ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA2048^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB1+2
	sub #(   ( $400 * ( 256/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB1+2
.endif


B1_DONE:
	; B2  B0 ̉BEI[o[ȂԏɈړ

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB2

	lda MAP_Y_MAPNO
	add #1
	cmp #( 256/32 )
	bpl Y_TOTOP

	; }bvɈړlɕύX
	lda #($400 * 256/32 )
	add MAP_FIELD_ADDR_MAPB2
	sta MAP_FIELD_ADDR_MAPB2
	bcc B2_DONE
	inc MAP_FIELD_ADDR_MAPB2+2
	bra B2_DONE

	Y_TOTOP:
	; }bvԏɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB2
	sub #(  (($400*256/32) * ( 256/32 -1 )) & $ffff )
	sta MAP_FIELD_ADDR_MAPB2
	bcc Y_TOTOP_HIGHSUB
	dec MAP_FIELD_ADDR_MAPB2+2
Y_TOTOP_HIGHSUB:

	;B
	;lda #(  ($400*128/32) * ( 128/32 -1 ) >>16 )
	;sub MAP_FIELD_ADDR_MAPB1+2

B2_DONE:

	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_256x256_state2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B3  B1 ̉EBEI[o[ȂԍɈړ

	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB3

	; B3  B1 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (256/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB3+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB3
	sub #(   ( $400 * ( 256/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	dec MAP_FIELD_ADDR_MAPB3+2

	:
	B1_DONE:
.if 0
	; 256x256ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA1024^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB3+2
	sub #(   ( $400 * ( 256/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB3+2
.endif



	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_512x512_state0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	;		0-31     32-63    64-95                     480-511
	;		MAP00    MAP01    MAP02 MAP03  MAP04  ....  MAP0f
	;		MAP10    MAP11    MAP12  ....               MAP1f
	;		             ......
	;		MAPf0    MAPf1    MAPf2  ....               MAPff


	; ȊȂcB
	; قƂ 128x128 Ɠ͂H
	;  Map XNo_32 <= (GrobalX - 8 - MONITOR_OFFSET7or8 )
	;  Map YNo <= (GrobalY - 8 - MONITOR_OFFSET7or8 ) >> 5

	; B0 = Base + Map XNo_32 *32
	;			+ Map YNo    * 32*32 * 16(  512/32 )

	lda MAP_FIELD_GROBALX
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((512/32 )<<5)
	bra :++

:	cmp #((512/32 )<<5)			; ЂƂ
	bmi :+
	sub #((512/32 )<<5)

:	and #$ffe0
	sta MAP_X_MAPNO_32


	lda MAP_FIELD_GROBALY
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((512/32 )<<5)
	bra :++

:	cmp #((512/32 )<<5)			; ЂƂ
	bmi :+
	sub #((512/32 )<<5)

	:
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	sta MAP_Y_MAPNO



	; B0  MAP_XNO * 0x400 ƂB
	; 0x0400*MapNo  : 0-15(MAX127), 0x0000-0x4000
	lda MAP_X_MAPNO_32		; X}bvԍ߂
	lsr
	lsr
	lsr
	pha
	lsr
	lsr
	sta MAP_X_MAPNO
	pla
	;								 0x0-0x7f
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+
	inc MAP_FIELD_ADDR_MAPB0+2
	
:	; ʂɂ܂ȂĂȁcB
	;inx
	;inx
	;lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	;add MAP_FIELD_ADDR_MAPB0+2




	; B0  MAP_YNO * 0x4000 ƂB
	; 0x4000*MapNo  : 0-15(max 7f), 0x4000-0x4 0000
	lda MAP_Y_MAPNO
	asl a
	asl a
	tax
	; 128 ȍ~͂̔z񂪕ςB
	lda MAP_CALC_MAP512x512_YNO,x			; Y_MAPNO * 0x4000 ̉ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+ 
	inc MAP_FIELD_ADDR_MAPB0+2			; オ蕪𑫂Ƃ
:

	; ʂ8bitAhXvZlB
	lda MAP_CALC_MAP512x512_YNO+2,x			; Y_MAPNO * 0x4000 ̏ʂ擾
	add MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB0+2

	inc MAP_MAPADDR_READY



	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_512x512_state1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1

	; B1  B0 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (512/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB1
	sub #(   ( $400 * ( 512/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	dec MAP_FIELD_ADDR_MAPB1+2

	:
.if 0
	; 512x512ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA1024^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB1+2
	sub #(   ( $400 * ( 512/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB1+2
.endif


B1_DONE:
	; B2  B0 ̉BEI[o[ȂԏɈړ

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB2

	lda MAP_Y_MAPNO
	add #1
	cmp #( 512/32 )
	bpl Y_TOTOP

	; }bvɈړlɕύX
	lda #($400 * 512/32 )
	add MAP_FIELD_ADDR_MAPB2
	bcc B2_DONE
	inc MAP_FIELD_ADDR_MAPB2+2
	bra B2_DONE

	Y_TOTOP:
	; }bvԏɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB2
	sub #(  (($400*512/32) * ( 512/32 -1 )) & $ffff )
	sta MAP_FIELD_ADDR_MAPB2
	bcc Y_TOTOP_HIGHSUB
	dec MAP_FIELD_ADDR_MAPB2+2
Y_TOTOP_HIGHSUB:

	lda MAP_FIELD_ADDR_MAPB2+2
	sub #(  ($400*512/32) * ( 512/32 -1 ) >>16 )
	sta MAP_FIELD_ADDR_MAPB2+2

B2_DONE:

	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_512x512_state2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B3  B1 ̉EBEI[o[ȂԍɈړ

	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB3

	; B3  B1 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (512/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB3+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB3
	sub #(   ( $400 * ( 512/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	dec MAP_FIELD_ADDR_MAPB3+2

	:
	B1_DONE:
.if 0
	; 512x512ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA2048^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB3+2
	sub #(   ( $400 * ( 512/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB3+2
.endif



	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc






; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_1024x1024_state0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy
	; 1024/32=32
	;		0-31     32-63    64-95                     992-1023
	;		MAP00    MAP01    MAP02 MAP03  MAP04  ....  MAP1f
	;		MAP20    MAP21    MAP22  ....               MAP3f
	;		             ......
	;		MAP3f0   MAP3f1   MAP3f2  ....              MAP3ff


	; ȊȂcB
	; قƂ 128x128 Ɠ͂H
	;  Map XNo_32 <= (GrobalX - 8 - MONITOR_OFFSET7or8 )
	;  Map YNo <= (GrobalY - 8 - MONITOR_OFFSET7or8 ) >> 5

	; B0 = Base + Map XNo_32 *32
	;			+ Map YNo    * 32*32 * 32(  1024/32 )

	lda MAP_FIELD_GROBALX
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((1024/32 )<<5)
	bra :++

:	cmp #((1024/32 )<<5)			; ЂƂ
	bmi :+
	sub #((1024/32 )<<5)

:	and #$ffe0
	sta MAP_X_MAPNO_32


	lda MAP_FIELD_GROBALY
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((1024/32 )<<5)
	bra :++

:	cmp #((1024/32 )<<5)			; ЂƂ
	bmi :+
	sub #((1024/32 )<<5)

	:
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	sta MAP_Y_MAPNO



	; B0  MAP_XNO * 0x400 ƂB
	; 0x0400*MapNo  : 0-31(MAX127), 0x0000-0x8000
	lda MAP_X_MAPNO_32		; X}bvԍ߂
	lsr
	lsr
	lsr
	pha
	lsr
	lsr
	sta MAP_X_MAPNO
	pla
	;								 0x0-0x7f
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+
	inc MAP_FIELD_ADDR_MAPB0+2
	
:	; ʂɂ܂ȂĂȁcB
	;inx
	;inx
	;lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	;add MAP_FIELD_ADDR_MAPB0+2




	; B0  MAP_YNO * 0x8000 ƂB
	; 0x8000*MapNo  : 0-31(max 7f), 0x8000-0x10 0000
	lda MAP_Y_MAPNO
	asl a
	asl a
	tax
	; 128 ȍ~͂̔z񂪕ςB
	lda MAP_CALC_MAP1024x1024_YNO,x			; Y_MAPNO * 0x8000 ̉ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+ 
	inc MAP_FIELD_ADDR_MAPB0+2			; オ蕪𑫂Ƃ
:

	; ʂ8bitAhXvZlB
	inc
	inc
	lda MAP_CALC_MAP1024x1024_YNO,x			; Y_MAPNO * 0x8000 ̏ʂ擾
	add MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB0+2

	inc MAP_MAPADDR_READY



	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_1024x1024_state1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1

	; B1  B0 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (1024/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB1
	sub #(   ( $400 * ( 1024/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	dec MAP_FIELD_ADDR_MAPB1+2

	:
.if 0
	; 1024x1024ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA2048^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB1+2
	sub #(   ( $400 * ( 1024/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB1+2
.endif


B1_DONE:
	; B2  B0 ̉BEI[o[ȂԏɈړ

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB2

	lda MAP_Y_MAPNO
	add #1
	cmp #( 1024/32 )
	bpl Y_TOTOP

	; }bvɈړlɕύX
	lda #($400 * 1024/32 )
	add MAP_FIELD_ADDR_MAPB2
	sta MAP_FIELD_ADDR_MAPB2
	bcc B2_DONE
	inc MAP_FIELD_ADDR_MAPB2+2
	bra B2_DONE

	Y_TOTOP:
	; }bvԏɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB2
	sub #(  (($400*1024/32) * ( 1024/32 -1 )) & $ffff )
	sta MAP_FIELD_ADDR_MAPB2
	bcc Y_TOTOP_HIGHSUB
	dec MAP_FIELD_ADDR_MAPB2+2
Y_TOTOP_HIGHSUB:

	lda MAP_FIELD_ADDR_MAPB2+2
	sub #(  ($400*1024/32) * ( 1024/32 -1 ) >>16 )
	sta MAP_FIELD_ADDR_MAPB2+2

B2_DONE:

	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc




; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_1024x1024_state2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B3  B1 ̉EBEI[o[ȂԍɈړ

	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB3

	; B3  B1 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (1024/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB3+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB3
	sub #(   ( $400 * ( 1024/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	dec MAP_FIELD_ADDR_MAPB3+2

	:
	B1_DONE:
.if 0
	; 1024x1024ł͈ȉZ͂Ԃ񔭐ȂB

	; 64 map,128ʁA2048^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB3+2
	sub #(   ( $400 * ( 1024/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB3+2
.endif



	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc











; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_2048x2048_state0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy
	; 2048/32=64
	;  64=0x40 0b0100 0000   64<<5 = 0x0800
	;		0-31     32-63    64-95                     2016-2047
	;		MAP00    MAP01    MAP02 MAP03  MAP04  ....  MAP3f
	;		MAP40    MAP41    MAP42  ....               MAP7f
	;		             ......
	;		MAPfc0   MAPfc1   MAPfc2  ....              MAPfff


	; ȊȂcB
	; قƂ 128x128 Ɠ͂H
	;  Map XNo_32 <= (GrobalX - 8 - MONITOR_OFFSET7or8 )
	;  Map YNo <= (GrobalY - 8 - MONITOR_OFFSET7or8 ) >> 5

	; B0 = Base + Map XNo_32 *32
	;			+ Map YNo    * 32*32 * 64(  2048/32 )

	lda MAP_FIELD_GROBALX
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((2048/32 )<<5)
	bra :++

:	cmp #((2048/32 )<<5)			; ЂƂ
	bmi :+
	sub #((2048/32 )<<5)

:	and #$ffe0
	sta MAP_X_MAPNO_32


	lda MAP_FIELD_GROBALY
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((2048/32 )<<5)
	bra :++

:	cmp #((2048/32 )<<5)			; ЂƂ
	bmi :+
	sub #((2048/32 )<<5)

	:
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	sta MAP_Y_MAPNO



	; B0  MAP_XNO * 0x400 ƂB
	; 0x0400*MapNo  : 0-31(MAX127), 0x0000-0x8000
	lda MAP_X_MAPNO_32		; X}bvԍ߂
	lsr
	lsr
	lsr
	pha
	lsr
	lsr
	sta MAP_X_MAPNO
	pla
	;								 0x0-0x7f
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+
	inc MAP_FIELD_ADDR_MAPB0+2
	
:	; ʂɂ܂ȂĂȁcB
	;inx
	;inx
	;lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	;add MAP_FIELD_ADDR_MAPB0+2


	; B0  MAP_YNO * 0x10000 ƂB
	; 0x1 0000*MapNo  : 0-31(max 7f), 0x10000-0x3f 0000
.if 0
	; ʂ2048ȍ~͑ȂB
	asl a
	asl a
	tax
	; 128 ȍ~͂̔z񂪕ςB
	lda MAP_CALC_MAP1024x1024_YNO,x			; Y_MAPNO * 0x8000 ̉ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+ 
	inc MAP_FIELD_ADDR_MAPB0+2			; オ蕪𑫂Ƃ
:

	; ʂ8bitAhXvZlB
	inc
	inc
.endif
	lda MAP_Y_MAPNO
	add MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB0+2

	inc MAP_MAPADDR_READY



	restore_paxy
	rts
.endproc




; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_2048x2048_state1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1

	; B1  B0 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (2048/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB1
	sub #(   ( $400 * ( 2048/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	dec MAP_FIELD_ADDR_MAPB1+2

	:
.if 0
	; 2048x2048ł͈ȉZ͂Ԃ񔭐ȂB
	; ꂥH
	; ł 0x10000 - 0x400 mɂ܂gȂȁB

	lda MAP_FIELD_ADDR_MAPB1+2
	sub #(   ( $400 * ( 2048/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB1+2
.endif



B1_DONE:
	; B2  B0 ̉BEI[o[ȂԏɈړ

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB2

	lda MAP_Y_MAPNO
	add #1
	cmp #( 2048/32 )
	bpl Y_TOTOP

	; }bvɈړlɕύX
	; y_MapNo P₷ƃAhX
	;  0x400 x 64(0x40) = 0x1 0000 ԒnvZɂȂB
	inc MAP_FIELD_ADDR_MAPB2+2
	bra B2_DONE

	Y_TOTOP:
	; }bv擪Ɉړ
	lda MAP_FIELD_ADDR_MAPB2+2
	sub #63	
	sta MAP_FIELD_ADDR_MAPB2+2


B2_DONE:

	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc


; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_2048x2048_state2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B3  B1 ̉EBEI[o[ȂԍɈړ

	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB3

	; B3  B1 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (2048/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB3+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB3
	sub #(   ( $400 * ( 2048/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	dec MAP_FIELD_ADDR_MAPB3+2

	:
	B1_DONE:
.if 0
	; 2048x2048ł͈ȉZ͂Ԃ񔭐ȂB
	; [[[ARǂȂł낤Aŏ
	; vZ͂ȂƎv̂ɁcB

	; 64 map,128ʁA2048^Cȏゾ
	; ̃[h߂17bitɂȂ邗
	lda MAP_FIELD_ADDR_MAPB3+2
	sub #(   ( $400 * ( 1024/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB3+2
.endif



	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_4096x4096_state0
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy
	; 4096/32=128
	;  128=0x80 0b1000 0000  128<<5 = 0x1000
	;		0-31     32-63    64-95                     4064-4097
	;		MAP00    MAP01    MAP02 MAP03  MAP04  ....  MAP7f
	;		MAP80    MAP81    MAP82  ....               MAPff
	;		             ......
	;		MAP3f80  MAP3f81   MAP3f82  ....              MAP3fff


	; ȊȂcB
	; قƂ 128x128 Ɠ͂H
	;  Map XNo_32 <= (GrobalX - 8 - MONITOR_OFFSET7or8 )
	;  Map YNo <= (GrobalY - 8 - MONITOR_OFFSET7or8 ) >> 5

	; B0 = Base + Map XNo_32 *32
	;			+ Map YNo    * 32*32 * 128(  4096/32 )

	lda MAP_FIELD_GROBALX
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((4096/32 )<<5)
	bra :++

:	cmp #((4096/32 )<<5)			; ЂƂ
	bmi :+
	sub #((4096/32 )<<5)

:	and #$ffe0
	sta MAP_X_MAPNO_32


	lda MAP_FIELD_GROBALY
	sub #(8 + MONITOR_OFFSET7or8)
	bpl :+						; }CiXɂȂĂ瑫  0 ̓vXAWv
	add #((4096/32 )<<5)
	bra :++

:	cmp #((4096/32 )<<5)			; ЂƂ
	bmi :+
	sub #((4096/32 )<<5)

	:
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	sta MAP_Y_MAPNO



	; B0  MAP_XNO * 0x400 ƂB
	; 0x0400*MapNo  : 0-127(MAX127), 0x0000-0x20000
	lda MAP_X_MAPNO_32		; X}bvԍ߂
	lsr
	lsr
	lsr
	pha
	lsr
	lsr
	sta MAP_X_MAPNO
	pla
	;								 0x0-0x7f
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+
	inc MAP_FIELD_ADDR_MAPB0+2
	
:	; ʂ
	inx
	inx
	lda MAP_CALC_MAP_XNO,x			; X_MAPNO * 0x400 ʂ擾
	add MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB0+2



	; B0  MAP_YNO * 0x20000 ƂB
	; 0x1 0000*MapNo  : 0-127(max 7f), 0x20000-0x100 0000
.if 0
	; ʂ2048ȍ~͑ȂB
	asl a
	asl a
	tax
	; 128 ȍ~͂̔z񂪕ςB
	lda MAP_CALC_MAP1024x1024_YNO,x			; Y_MAPNO * 0x8000 ̉ʂ擾
	add MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB0
	bcc :+ 
	inc MAP_FIELD_ADDR_MAPB0+2			; オ蕪𑫂Ƃ
:

	; ʂ8bitAhXvZlB
	inc
	inc
.endif
	lda MAP_Y_MAPNO
	asl a
	add MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB0+2

	inc MAP_MAPADDR_READY



	restore_paxy
	rts
.endproc



; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_4096x4096_state1
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB1+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB1

	; B1  B0 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (4096/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB1
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB1+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB1
	sub #(   ( $400 * ( 4096/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB1
	bcc :+
	dec MAP_FIELD_ADDR_MAPB1+2

	:
	; ʃAhXB

	lda MAP_FIELD_ADDR_MAPB1+2
	sub #(   ( $400 * ( 4096/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB1+2



B1_DONE:
	; B2  B0 ̉BEI[o[ȂԏɈړ

	lda MAP_FIELD_ADDR_MAPB0+2
	sta MAP_FIELD_ADDR_MAPB2+2
	lda MAP_FIELD_ADDR_MAPB0
	sta MAP_FIELD_ADDR_MAPB2

	lda MAP_Y_MAPNO
	add #1
	cmp #( 4096/32 )
	bpl Y_TOTOP

	; }bvɈړlɕύX
	; y_MapNo P₷ƃAhX
	;  0x400 x 64(0x40) = 0x1 0000 ԒnvZɂȂB
	inc MAP_FIELD_ADDR_MAPB2+2
	bra B2_DONE

	Y_TOTOP:
	; }bv擪Ɉړ
	lda MAP_FIELD_ADDR_MAPB2+2
	sub #127
	sta MAP_FIELD_ADDR_MAPB2+2


B2_DONE:

	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc





; A16, I16
; }bvAhXASZbg
.proc MapBaseAddrSet_4096x4096_state2
; ( MapSetTileData ̂݌Ă΂邽߃Wv߂łɗ)
.a16
.i16
	;save_paxy

	; B3  B1 ̉EBEI[o[ȂԍɈړ

	lda MAP_FIELD_ADDR_MAPB1+2
	sta MAP_FIELD_ADDR_MAPB3+2
	lda MAP_FIELD_ADDR_MAPB1
	sta MAP_FIELD_ADDR_MAPB3

	; B3  B1 ̉EƂȂBEI[o[Ȃ獶[Ɉړ
	lda MAP_X_MAPNO
	add #1
	cmp #( (4096/32) )
	bpl X_TOTOP
	; }bvEɈړlɕύX
	lda #$400
	add MAP_FIELD_ADDR_MAPB3
	sta MAP_FIELD_ADDR_MAPB3
	bcc B1_DONE
	inc MAP_FIELD_ADDR_MAPB3+2
	bra B1_DONE

	X_TOTOP:
	; }bv[ɈړlɕύX
	lda MAP_FIELD_ADDR_MAPB3
	sub #(   ( $400 * ( 4096/32 -1 ) ) & $ffff )
	sta MAP_FIELD_ADDR_MAPB3
	bcc :+
	dec MAP_FIELD_ADDR_MAPB3+2

	:
	B1_DONE:
	; ʂB
	lda MAP_FIELD_ADDR_MAPB3+2
	sub #(   ( $400 * ( 4096/32 -1 ) ) >>16 )
	sta MAP_FIELD_ADDR_MAPB3+2



	inc MAP_MAPADDR_READY

	restore_paxy
	rts
.endproc











FIELDNO_ADDRS:
	.dword Field1MapData

FIELDNO_WDITHS:
	.byte	0
FIELDNO_HEIGHTS:
	.word	64



MAKEADDR_WIDTHX_POINTERS:
	.word	MapBaseAddrSet_32x32,				0,			0,				0			; width=0, 32x32map

	.word	MapBaseAddrSet_64x64_State0,		MapBaseAddrSet_64x64_State1				; width=1, 64x64map
	.word	MapBaseAddrSet_64x64_State2,		0

	.word	MapBaseAddrSet_128x128_state0,		MapBaseAddrSet_128x128_state1			; width=2, 128x128 map
	;											ʉAg񂵂
	.word	MapBaseAddrSet_128x128_state2,		MapBaseAddrSet_64x64_State2

	.word	MapBaseAddrSet_256x256_state0,		MapBaseAddrSet_256x256_state1			; width=3, 256x256 map
	;											ʉAg񂵂
	.word	MapBaseAddrSet_256x256_state2,		MapBaseAddrSet_64x64_State2

	.word	MapBaseAddrSet_512x512_state0,		MapBaseAddrSet_512x512_state1			; width=4, 512x512 map
	;											ʉAg񂵂
	.word	MapBaseAddrSet_512x512_state2,		MapBaseAddrSet_64x64_State2

	.word	MapBaseAddrSet_1024x1024_state0,	MapBaseAddrSet_1024x1024_state1			; width=5, 1024x1024 map
	;											ʉAg񂵂
	.word	MapBaseAddrSet_1024x1024_state2,	MapBaseAddrSet_64x64_State2

	.word	MapBaseAddrSet_2048x2048_state0,	MapBaseAddrSet_2048x2048_state1			; width=5, 2048x2048 map
	;											ʉAg񂵂
	.word	MapBaseAddrSet_2048x2048_state2,	MapBaseAddrSet_64x64_State2

	.word	MapBaseAddrSet_4096x4096_state0,	MapBaseAddrSet_4096x4096_state1			; width=6, 4096x4096 map
	;											ʉAg񂵂
	.word	MapBaseAddrSet_4096x4096_state2,	MapBaseAddrSet_64x64_State2




SDMAFUNC_POINTERS:
	.word	MapVramWrite_WriteVmaAddr,	MapVramWrite_WriteRomRawDatas



MAP_CALC_MAP_XNO:
	.dword	$400*$00, $400*$01, $400*$02, $400*$03,   $400*$04, $400*$05, $400*$06, $400*$07
	.dword	$400*$08, $400*$09, $400*$0a, $400*$0b,   $400*$0c, $400*$0d, $400*$0e, $400*$0f
	.dword	$400*$10, $400*$11, $400*$12, $400*$13,   $400*$14, $400*$15, $400*$16, $400*$17
	.dword	$400*$18, $400*$19, $400*$1a, $400*$1b,   $400*$1c, $400*$1d, $400*$1e, $400*$1f
	.dword	$400*$20, $400*$21, $400*$22, $400*$23,   $400*$24, $400*$25, $400*$26, $400*$27
	.dword	$400*$28, $400*$29, $400*$2a, $400*$2b,   $400*$2c, $400*$2d, $400*$2e, $400*$2f
	.dword	$400*$30, $400*$31, $400*$32, $400*$33,   $400*$34, $400*$35, $400*$36, $400*$37
	.dword	$400*$38, $400*$39, $400*$3a, $400*$3b,   $400*$3c, $400*$3d, $400*$3e, $400*$3f
                                                                                          
	.dword	$400*$40, $400*$41, $400*$42, $400*$43,   $400*$44, $400*$45, $400*$46, $400*$47
	.dword	$400*$48, $400*$49, $400*$4a, $400*$4b,   $400*$4c, $400*$4d, $400*$4e, $400*$4f
	.dword	$400*$50, $400*$51, $400*$52, $400*$53,   $400*$54, $400*$55, $400*$56, $400*$57
	.dword	$400*$58, $400*$59, $400*$5a, $400*$5b,   $400*$5c, $400*$5d, $400*$5e, $400*$5f
	.dword	$400*$60, $400*$61, $400*$62, $400*$63,   $400*$64, $400*$65, $400*$66, $400*$67
	.dword	$400*$68, $400*$69, $400*$6a, $400*$6b,   $400*$6c, $400*$6d, $400*$6e, $400*$6f
	.dword	$400*$70, $400*$71, $400*$72, $400*$73,   $400*$74, $400*$75, $400*$76, $400*$77
	.dword	$400*$78, $400*$79, $400*$7a, $400*$7b,   $400*$7c, $400*$7d, $400*$7e, $400*$7f

.if 0                                                                                          
	.dword	$400*$80, $400*$81, $400*$82, $400*$83,   $400*$84, $400*$85, $400*$86, $400*$87
	.dword	$400*$88, $400*$89, $400*$8a, $400*$8b,   $400*$8c, $400*$8d, $400*$8e, $400*$8f
	.dword	$400*$90, $400*$91, $400*$92, $400*$93,   $400*$94, $400*$95, $400*$96, $400*$97
	.dword	$400*$98, $400*$99, $400*$9a, $400*$9b,   $400*$9c, $400*$9d, $400*$9e, $400*$9f
	.dword	$400*$a0, $400*$a1, $400*$a2, $400*$a3,   $400*$a4, $400*$a5, $400*$a6, $400*$a7
	.dword	$400*$a8, $400*$a9, $400*$aa, $400*$ab,   $400*$ac, $400*$ad, $400*$ae, $400*$af
	.dword	$400*$b0, $400*$b1, $400*$b2, $400*$b3,   $400*$b4, $400*$b5, $400*$b6, $400*$b7
	.dword	$400*$b8, $400*$b9, $400*$ba, $400*$bb,   $400*$bc, $400*$bd, $400*$be, $400*$bf
                                                                                          
	.dword	$400*$c0, $400*$c1, $400*$c2, $400*$c3,   $400*$c4, $400*$c5, $400*$c6, $400*$c7
	.dword	$400*$c8, $400*$c9, $400*$ca, $400*$cb,   $400*$cc, $400*$cd, $400*$ce, $400*$cf
	.dword	$400*$d0, $400*$d1, $400*$d2, $400*$d3,   $400*$d4, $400*$d5, $400*$d6, $400*$d7
	.dword	$400*$d8, $400*$d9, $400*$da, $400*$db,   $400*$dc, $400*$dd, $400*$de, $400*$df
	.dword	$400*$e0, $400*$e1, $400*$e2, $400*$e3,   $400*$e4, $400*$e5, $400*$e6, $400*$e7
	.dword	$400*$e8, $400*$e9, $400*$ea, $400*$eb,   $400*$ec, $400*$ed, $400*$ee, $400*$ef
	.dword	$400*$f0, $400*$f1, $400*$f2, $400*$f3,   $400*$f4, $400*$f5, $400*$f6, $400*$f7
	.dword	$400*$f8, $400*$f9, $400*$fa, $400*$fb,   $400*$fc, $400*$fd, $400*$fe, $400*$ff

.endif

MAP_CALC_YPOS:
	.word	$20*$00, $20*$01, $20*$02, $20*$03,   $20*$04, $20*$05, $20*$06, $20*$07
	.word	$20*$08, $20*$09, $20*$0a, $20*$0b,   $20*$0c, $20*$0d, $20*$0e, $20*$0f
	.word	$20*$10, $20*$11, $20*$12, $20*$13,   $20*$14, $20*$15, $20*$16, $20*$17
	.word	$20*$18, $20*$19, $20*$1a, $20*$1b,   $20*$1c, $20*$1d, $20*$1e, $20*$1f


MAP_CALC_MAP128x128_YNO:
	.dword	$1000*$00, $1000*$01, $1000*$02, $1000*$03
MAP_CALC_MAP256x256_YNO:
	.dword	$2000*$00, $2000*$01, $2000*$02, $2000*$03
	.dword	$2000*$04, $2000*$05, $2000*$06, $2000*$07
MAP_CALC_MAP512x512_YNO:
	.dword	$4000*$00, $4000*$01, $4000*$02, $4000*$03,  $4000*$04, $4000*$05, $4000*$06, $4000*$07
	.dword	$4000*$08, $4000*$09, $4000*$0a, $4000*$0b,  $4000*$0c, $4000*$0d, $4000*$0e, $4000*$0f
MAP_CALC_MAP1024x1024_YNO:
	.dword	$8000*$00, $8000*$01, $8000*$02, $8000*$03,  $8000*$04, $8000*$05, $8000*$06, $8000*$07
	.dword	$8000*$08, $8000*$09, $8000*$0a, $8000*$0b,  $8000*$0c, $8000*$0d, $8000*$0e, $8000*$0f
	.dword	$8000*$10, $8000*$11, $8000*$12, $8000*$13,  $8000*$14, $8000*$15, $8000*$16, $8000*$17
	.dword	$8000*$18, $8000*$19, $8000*$1a, $8000*$1b,  $8000*$1c, $8000*$1d, $8000*$1e, $8000*$1f







