.setcpu "65816"
.autoimport on
.include "inc/common-macros.inc"
.include "inc/GlobalVars.inc"
.include "inc/resource-macros.inc"
.include "inc/ports.inc"

.include "inc/pad-bits.inc"


.macro monsDataMacro tilex, tiley
	.word kMap1StartW_2 + $20 * tiley + tilex
	.word 32* tiley + tilex
.endmacro


;.import MonsChrData:far
.import Field1ChrData:far
.import Field1MapData:far

.export sceneInit

.export updateScene
.export renderScene
.export processInput

.export MONSACT00_00_ADDR:far





;@@ʏ탋[v(UpdateScene)ŃAjp^[AHDMAe[u
;@@B
;@@荞݂HDMA]
;@@VRAM\(AhXꏏȂ)
;@@
;
;@@BG1 F lԂ̊Og(ρB)
;@@BG2 : uƏvXN[WX^ŕ`H
;@@BG3 F wiB

;@@J[pbgt[ɕύXB
;@@IXvCgA16/256 HDMA]
;@@Fg؂ĂȂB
;@@window }XNWX^ABGʂ̐FĂȂB
;@@F̃t[ύX
;@@VRAM ItZbgύXƂchr̃AhXύXĂȂB
;
;@@gkB퓬Aj[VB
;@@EɉBhB
;@@EɉBꂽ܂ܓˌėB
;@@EォU艺낷B
;@@EɐUB
;@@E
;@@EEɃ[O
;@@E𓊂̂Ăė莝ɂȂB
;@@E
;@@H
;
;@@@lp`ƂŎH
;@@@ŏIIɂ́AuXJCvȂ񂾂ȂcB
;@@@uFF11vŐ퓬SAO
;@@@Ђ퓬ĂЂ烌xグ銴H
;@@@
;@@@@PɃ_WŁAuK_u[fBYj[v
;@@@@̍ogŌ̐킢̃C[WH
;@@@@
;@@@@
;@@@@ZpIɃX[t@~RcogłI
;@@@@Ƃ܂ł͂ƂĂ݂Ȃ
;@@@@Aɂ́cB
;@@@@PɉʍXVSԂɍȂ肪B
;@@@@@@ṓugʂŕI
;@@@@@@EΏo񂶂ˁH
;@@@@ƂiKH
;@@@@ׂɁAHDMȂшSgΏoCcB





;
;



; A16, I16
.proc sceneInit
.a16
.i16
	save_paxy

	jsr resetScroll
	jsr disableScreen
	jsr disableNMI
	jsr forceStopHDMA
	
	stz gPadState
	stz gRotAngle
	
	stz gPositionX
	stz gPositionY
	stz gScrollX
	stz gScrollY
	stz gPlayerVX
	stz gPlayerVY
	stz gGlobalCount
	stz gPlayerFrameCount
	stz gPlayerTileBase

	stz gTransCX
	stz gTransCY

	lda #0
	sta gMONS_0_CNT

	stz gMONS_0_READY
	stz gMONS_FINISHED
	stz gGlobalCount2
	stz gIGNORE_VHCOUNTER_CNT

	;stz gTransSin
	;stz gTransNSin
	;ldsta gTransCos, #$0100
	

	; LOAD
	;ldx #128
	;ldy #128
	ldx #0
	ldy #0
	jsr transferPaletteDataBulk8

	ldx #0
	ldy #0
	jsr transferField1PaletteData
	
	; pbgf[^fontDŏ㏑
	;jsr transferFontPaletteData

	; CLEAR
	;lda #$0
	;ldy #$2000
	;jsr clearVRAMDirect


	; CLEAR
	lda #$6000
	ldy #$0400
	jsr clearVRAMDirect


	;loadWithAssetAddress MonsChrData, #$0000, #$2400
	loadWithAssetAddress Field1ChrData, #$0000, #$1000

.if 0
	; VRAMt0000ffŖ߂B
	lda #$0
	sta pVWriteAddrW
	ldy #$100
	lda #$ffff
:	sta pVWriteValW
	dey
	bne :-
.endif

	;loadWithAssetAddress FontData, #$4000, #$600
	;loadWithAssetAddress Field1MapData, #$6000, #$480
	lda #$6000
	sta pVWriteAddrW

	ldy #480
	ldx #0
	lda #0
	:
	set_a8
	lda f:Field1MapData,x
	set_a16
	sta pVWriteValW						; 5

	inx
	dey
	bne :-

	;jsr spSetWhiteFill
	
	;jsr initVideoForMode7
	jsr initVideoForGame
	;jsr transferBGData
	;jsr transferSkyMapData
	; BG1]
	;jsr transferBG1Data

.if 0
	;jsr transferFontTileMapData
	lda #$6000
	ldy #$1000
	jsr clearVRAMDirect
.endif


	ldx #2 ; select pattern area
	jsr spConfigureForGame
	jsr spClearDirect
	;jsr spInitShip
	;jsr spInitTitle
	;jsr spSetTest

	;jsr writeBGTransform
	;jsr updateScroll


	; VBLank |C^ݒ
	lda #.LOWORD(VBlank_MainLoop)
	sta VBLANK_POINTER

	set_a8
.a8
	; ȉxŎ擾悤ƂƁA
	; xoN00AROMSTACODEGAɔzuĂ̂
	; 00 ȂB
	; Ȃ 80,0000 ` 00,8000Ԓn~[Ă̂
	; ȉ͂ǂłBƂ炵cB
	;lda #.LOBYTE(.HIWORD(VBlank_MainLoop))
	lda #$80
.a16
	sta VBLANK_POINTER+2
	set_a16


	; RSUME SCREEN
	jsr enableNMI
	ldx #$0F
	jsr enableScreensWithBrightness

	restore_paxy
	rts
.endproc



; A16, I16
.proc VBlank_MainLoop
.a16
.i16

	jsr renderScene
	jsr updatePadState

	inc gRenderFinished

	;pld

	pla ; A16bitŕA
	plp ; 荞ݑOP𕜋A
	rti
.endproc


; --------------------------------------------
.proc updatePadState
	set_a8
	.a8 

	; Wait until auto-read is finished
:	lda $4212
	and #$01
	bne :-

	set_a16
	.a16

	; Store Pad Status
	lda $4218
	sta gPadState

	rts
.endproc





; A16, I16
.proc updateScene
.a16
.i16
	save_paxy
	mEnableHighClockMode

	;jsr setupTransformHDMATable

	;jsr updateVelocity
	;jsr applyVelocity

	inc gGlobalCount

	; gPlayerFrameCount += gGlobalCount & 0x1
	lda gGlobalCount
	and #$01
	add gPlayerFrameCount
	sta gPlayerFrameCount
	

	;jsr PrepareHBlankTransfer


	restore_paxy
	rts
.endproc

; xxNg֌W

; xxNg = =
.macro ldy_negflag_abs
	bpl :+
		eor #$FFFF
		inc ; ]
		ldy #1
		bra :++
	:
		ldy #0
	:
.endmacro
; A16, I16
.proc updateVelocity
.a16
.i16
	save_paxy
	; v = v*16/17 Ō
	; a=16 max ̂Ƃ v=240ŋύt

	lda gPlayerVY
	ldy_negflag_abs
	; Y <- original is neg?
	; A <- abs(VY)
	
	left_shift_4
	sta pDivc_dividend

set_a8
.a8
	lda #17
	sta pDivc_divisor
set_a16
.a16	

	
	; ʑ҂̊ԂɎ̌vZĂ ----
	lda gPlayerVX  ; 4c
	eor #$FFFF     ; 3c
	inc            ; 2c
	tax            ; 2c
	; ܂11TCN
	
	xba ; 3c wait
	xba ; 3c wait
	; --------------------------------------
	
	lda pDivc_outQ
	
	cpy #0
	beq no_yinv ; ēx]
		eor #$FFFF
		inc
	no_yinv:

	sta gPlayerVY

	; X = = =
	ldy #0
	
	lda gPlayerVX
	bpl X_positive
		iny
		txa
	X_positive:

	left_shift_4
	sta pDivc_dividend
	
set_a8
.a8
	lda #17
	sta pDivc_divisor
set_a16
.a16

	wait_divcycles
	
	lda pDivc_outQ

	cpy #0
	beq no_Xinv ; ēx]
		eor #$FFFF
		inc
	no_Xinv:
	
	sta gPlayerVX

	restore_paxy
	rts
.endproc

.define kPosWrap #$3FFF

; A16, I16
.proc applyVelocity
.a16
.i16
	save_paxy

	lda gPositionX
	add gPlayerVX
	and kPosWrap
	sta gPositionX

	lda gPositionY
	add gPlayerVY
	and kPosWrap
	sta gPositionY

	restore_paxy
	rts
.endproc



.if 0
; HDMAZbgAbv
;
.proc setupTransformHDMATable
.a16
.i16
	save_paxy
	
	; Init table lookup offset
	lda #$3F00
	sta gSinTableOfs

	lda #96
	sta gHDMATable_TrA
	sta gHDMATable_TrB
	sta gHDMATable_TrC
	sta gHDMATable_TrD

	lda #$0100
	sta gHDMATable_TrA+1
	stz gHDMATable_TrB+1
	stz gHDMATable_TrC+1
	sta gHDMATable_TrD+1


	ldy #64
	ldx #3
	lp:
		lda #2
		sta gHDMATable_TrA,x
		sta gHDMATable_TrB,x
		sta gHDMATable_TrC,x
		sta gHDMATable_TrD,x
		inx
		
		lda gRotAngle
		jsr pickTblCos
		sta gHDMATable_TrA,x
		sta gHDMATable_TrD,x

		lda gRotAngle
		jsr pickTblSin
		sta gHDMATable_TrB,x

		eor #$FFFF ; -sin
		inc
		sta gHDMATable_TrC,x

		inxinx

		lda gSinTableOfs
		sub #256
		sta gSinTableOfs
		
		; - - - -
		dey
		bne lp
		
	stz gHDMATable_TrA,x ; Terminator
	stz gHDMATable_TrB,x ; Terminator
	stz gHDMATable_TrC,x ; Terminator
	stz gHDMATable_TrD,x ; Terminator

	restore_paxy
	rts
.endproc
.endif



; HDMAZbgAbv
;
; VRAM ݍς̂ƐV̂˂킹
;
.proc setupTransformHDMATable
.a16
.i16
	save_paxy
	
	; Init table lookup offset
	lda #$3F00
	sta gSinTableOfs

	lda #96
	sta gHDMATable_TrA
	sta gHDMATable_TrB
	sta gHDMATable_TrC
	sta gHDMATable_TrD

	lda #$0100
	sta gHDMATable_TrA+1
	stz gHDMATable_TrB+1
	stz gHDMATable_TrC+1
	sta gHDMATable_TrD+1


	ldy #64
	ldx #3
	lp:
		lda #2
		sta gHDMATable_TrA,x
		sta gHDMATable_TrB,x
		sta gHDMATable_TrC,x
		sta gHDMATable_TrD,x
		inx
		
		lda gRotAngle
		;jsr pickTblCos
		sta gHDMATable_TrA,x
		sta gHDMATable_TrD,x

		lda gRotAngle
		;jsr pickTblSin
		sta gHDMATable_TrB,x

		eor #$FFFF ; -sin
		inc
		sta gHDMATable_TrC,x

		inxinx

		lda gSinTableOfs
		sub #256
		sta gSinTableOfs
		
		; - - - -
		dey
		bne lp
		
	stz gHDMATable_TrA,x ; Terminator
	stz gHDMATable_TrB,x ; Terminator
	stz gHDMATable_TrC,x ; Terminator
	stz gHDMATable_TrD,x ; Terminator

	restore_paxy
	rts
.endproc













; A16, I16
.proc renderScene		; VBLANK 荞݂Ă΂
.a16
.i16
	save_paxy
	mEnableHighClockMode

	jsr processInput
	jsr calcScrollAmount

	;jsr spUpdateShip
	;jsr sendPaletteAnimation
	;jsr SetDynamicPalette

	jsr writeBGTransform

	;jsr prepareTransformHDMA
	;jsr prepareScrollHDMA
	;jsr prepareFadeHDMA
	;jsr SetMonsterHDMATable
	;jsr executeAllHDMA


	out_scanpos gBenchmarkOut
	restore_paxy
	rts
.endproc

; A16, I16
.proc sendPaletteAnimation
.a16
.i16
	save_paxy

set_a8
.a8

	; entry index
	lda #40
	sta pCGRAMAddr

	lda gGlobalCount
	lsr
	and #$1E
	tax


	; ̂܂܂DirectModeɂȂāADataBamkReg:00 ŃANZX?
	; ۂɂROM 81:0000 ɂ̃f[^͂邩
	lda AnimColorTable,x
	sta pCGRAMWrite
	lda AnimColorTable+1,x
	sta pCGRAMWrite
set_a16
.a16

	restore_paxy
	rts
.endproc

; A16, I16
.proc processInput
.a16
.i16
	save_paxy

	stz gPlayerTileBase

	; ROTATE

	lda gPlayerVX
	bne no_D
	lda gPlayerVY
	bne no_D


	lda gPadState
	bit kPad16_Right
	beq no_R
		ldsta gPlayerTileBase,#$4006 ; flip

		;lda gRotAngle
		;dec
		;dec
		;and #$00FF
		;sta gRotAngle

		; NMI,1/30b̊Ԃ 16dot B
		; 3016dot A32JEgłȂ
		lda #32
		sta gPlayerVX
	no_R:

	lda gPadState
	bit kPad16_Left
	beq no_L
		ldsta gPlayerTileBase,#$0004
		
		;lda gRotAngle
		;inc
		;inc
		;and #$00FF
		;sta gRotAngle

		;lda gPlayerVX
		;sub #$7f00
		lda #-32
		sta gPlayerVX
	no_L:


	lda gPadState
	bit kPad16_Up
	beq no_U
		ldsta gPlayerTileBase,#$0004
		
		;lda gRotAngle
		;inc
		;inc
		;and #$00FF
		;sta gRotAngle
		
		;lda gPlayerVY
		;sub #$7f00
		lda #-32
		sta gPlayerVY
	no_U:

	lda gPadState
	bit kPad16_Down
	beq no_D
		ldsta gPlayerTileBase,#$0004
		
		;lda gRotAngle
		;inc
		;inc
		;and #$00FF
		;sta gRotAngle

		;lda gPlayerVY
		;add #$7f00
		lda #32
		sta gPlayerVY
	no_D:


	; fwd - - - - - - -
	lda gPadState
	bit kPad16_TrgA
	beq no_A
		lda gPlayerFrameCount
		bit #$01
		beq :+
			lda #$08
			tsb gPlayerTileBase
		:

	no_A:


	restore_paxy
	rts
.endproc





.if 0

; A16, I16
.proc transferBGData
.a16
.i16
	save_paxy

	lda #$8000
	sta pVWriteAddrW
	
	ldx #0
	ldy #16384
	lp:
		lda f:M7BGData,x
		sta pVWriteValW

		inxinx
		; - - -
		dey
		bne lp
	

	restore_paxy
	rts
.endproc

.endif


; A16, I16
.proc transferFontTileMapData
.a16
.i16
	save_paxy

	lda #$6000
	sta pVWriteAddrW
	
	ldx #0
	ldy #(32*22)
	lp:
		txa
		ror a
		;ora #$c400
		sta pVWriteValW

		inxinx
		; - - -
		dey
		bne lp

	; c̓[Ŗ߂
	ldy #(32*28)
	:
		stz pVWriteValW
		dey
		bne :-



	restore_paxy
	rts
.endproc



.if 0

; A16, I16
.proc transferSkyMapData
.a16
.i16
	save_paxy

	lda #$7000
	sta pVWriteAddrW
	
	ldx #0
	ldy #(32*38)
	lp:
		lda f:SkyMapData,x
		sta pVWriteValW

		inxinx
		; - - -
		dey
		bne lp
	

	restore_paxy
	rts
.endproc

.endif

; A16, I16

.macro send_transform port,var
	lda var
	sta port

	lda var+1
	sta port
.endmacro

.proc writeBGTransform
.a16
.i16
	save_paxy


	; BG configuration
set_a8
.a8

	; init transform

	; BG0 XN[WX^0X ɏ
	lda gScrollX
	sta pScrollX0
	lda gScrollX+1
	sta pScrollX0

	; BG0 XN[WX^0Y ɏ
	lda gScrollY
	sta pScrollY0
	lda gScrollY+1
	sta pScrollY0


set_a16
.a16

	restore_paxy
	rts
.endproc

.proc updateScroll
.a16
.i16
	save_paxy

set_a8
.a8

;	lda gScrollX
;	sta pScrollX0
;	lda gScrollX+1
;	sta pScrollX0

;	lda gScrollY
;	sta pScrollY0
;	lda gScrollY+1
;	sta pScrollY0

set_a16
.a16

	restore_paxy
	rts
.endproc

.proc calcScrollAmount
.a16
.i16
	save_paxy

	; scrolling sky BG
	;lda gRotAngle
	;left_shift_2
	;eor #$FFFF
	;sta gHScrollHDMATable+1

	;lda gPositionX
	;right_shift_4 ; fixed -> int
	;sta gScrollX
	;sta gHScrollHDMATable+4

	;lda gPositionY
	;right_shift_4 ; fixed -> int
	;sta gScrollY
	;sta gVScrollHDMATable+4

	lda gPlayerVX
	beq CalcY
	bmi MinusX


	;AddX:
	sub #1
	sta gPlayerVX
	and #$01			; 0 XN[Ȃ
	beq EndXYAddSub
	
	lda gScrollX
	add #1

	and #$03ff
	sta gScrollX
	bra EndXYAddSub




	MinusX:
	add #1
	sta gPlayerVX
	and #1			; 0 XN[Ȃ
	beq EndXYAddSub

	lda gScrollX
	sub #1

	and #$03ff
	sta gScrollX
	bra EndXYAddSub






CalcY:

	lda gPlayerVY
	beq EndXYAddSub
	bmi MinusY

	PlusY:
	sub #1
	sta gPlayerVY
	and #$01			; 0 XN[Ȃ
	beq EndXYAddSub
	
	lda gScrollY
	add #1

	and #$03ff
	sta gScrollY
	bra EndXYAddSub


	MinusY:
	add #1
	sta gPlayerVY
	and #$01			; 0 XN[Ȃ
	beq EndXYAddSub
	
	lda gScrollY
	sub #1

	and #$03ff
	sta gScrollY
	bra EndXYAddSub






EndXYAddSub:

	restore_paxy
	rts
.endproc


; J[pbgOɏ
.proc SetDynamicPalette
.a16
.i16
	save_paxy

	set_a8
	.a8

	; Set write position
	lda #$1
	sta pCGRAMAddr

	lda		gGlobalCount
	and		#$1
	cmp		#$1
	beq		:+

	lda		#$ff
	sta		pCGRAMWrite
	lda		#$7f
	sta		pCGRAMWrite
	bra		:++
	:
	lda		#$9c
	sta		pCGRAMWrite
	lda		#$73
	sta		pCGRAMWrite
	:

	set_a16
	.a16

	restore_paxy
	rts
.endproc







; HDMA e[uɃAjp^[Ă݂B

; A16, I16
.proc PrepareHBlankTransfer
.a16
.i16
	save_paxy

	lda		gMONS_FINISHED
	; VRAM ݂ŝ
	; 3񂮂炢͏݂邗
	cmp		$01
	beq		donothing


	lda		gMONS_0_CNT
	bne		donothing

	; KɂPČ邗Ⴄ񂾂
	lda		#(92/2 - 1 + 1)
	;lda		#3
	sta		gMONS_0_CNT
	stz		gMONS_0_POS

	lda		#.LOWORD(MONSACT00_00_ADDR)
	sta		gSDMA_TBLADDR

	; ȂƎvǈꉞݒ肵ƂB
	; ȂƂ͎v񂾂ǁEEEB
	stz		gMONS_0_READY

donothing:
	inc		gMONS_FINISHED


	restore_paxy
	rts
.endproc








; nHDMA

; A16, I16
.proc executeAllHDMA
.a16
.i16
	save_paxy
	

	set_a8
	.a8
		; ---------------------------------------------
		; Enable HDMA Ch0-1
		;lda #$03
		lda #$03
		sta pHDMATrigger

	set_a16
	.a16

	restore_paxy
	rts
.endproc





AnimColorTable:
.word $221f, $21ff, $1dde, $1dbc, $199a, $1978, $1556, $1535
.word $1113, $10f1, $0ccf, $0cad, $088b, $0869, $0447, $0426



; EEEX^[ړAݍς̂ȁEEEB
; ǂlĂш摫ȁcB
MONSACT00_00:
.word MONSACT00_00_ADDR

; VRAM  0x6000 word AhX炠ƂāA
; 1024p^[ 2bit/4-colorƂ
; 32x32=0x20 x 0x20 = 0x400 鎖ɂȂB

MONSACT00_00_ADDR:		; 0x40 * y + x*2

; v92

; 3
monsDataMacro  8, 0
monsDataMacro  9, 0
monsDataMacro 10, 0


.if 0

; 3
monsDataMacro  7, 1
monsDataMacro  8, 1
monsDataMacro 10, 1
; 3
monsDataMacro  7, 2
monsDataMacro  8, 2
monsDataMacro 10, 2
; 3
monsDataMacro  8, 3
monsDataMacro  9, 3
monsDataMacro 10, 3
; 9
monsDataMacro  5, 4
monsDataMacro  6, 4
monsDataMacro  7, 4
monsDataMacro  8, 4
monsDataMacro  9, 4
monsDataMacro 10, 4
monsDataMacro 11, 4
monsDataMacro 12, 4
monsDataMacro 13, 4
; 3
monsDataMacro  4, 5
monsDataMacro  5, 5
monsDataMacro 13, 5
; 3
monsDataMacro  5, 6
monsDataMacro 12, 6
monsDataMacro 13, 6
; 3
monsDataMacro  5, 7
monsDataMacro 11, 7
monsDataMacro 13, 7
; 6
monsDataMacro  5, 8
monsDataMacro  6, 8
monsDataMacro  7, 8
monsDataMacro 10, 8
monsDataMacro 11, 8
monsDataMacro 12, 8
; 7
monsDataMacro  5, 9
monsDataMacro  6, 9
monsDataMacro  7, 9
monsDataMacro 10, 9
monsDataMacro 11, 9
monsDataMacro 12, 9
monsDataMacro 13, 9
; 5
monsDataMacro  5,10
monsDataMacro  7,10
monsDataMacro 10,10
monsDataMacro 11,10
monsDataMacro 13,10
; 9
monsDataMacro  5,11
monsDataMacro  6,11
monsDataMacro  7,11
monsDataMacro  8,11
monsDataMacro  9,11
monsDataMacro 10,11
monsDataMacro 11,11
monsDataMacro 12,11
monsDataMacro 13,11
; 7
monsDataMacro  5,12
monsDataMacro  6,12
monsDataMacro  7,12
monsDataMacro  9,12
monsDataMacro 11,12
monsDataMacro 12,12
monsDataMacro 13,12
; 5
monsDataMacro  7,13
monsDataMacro  8,13
monsDataMacro  9,13
monsDataMacro 10,13
monsDataMacro 11,13
; 5
monsDataMacro  6,14
monsDataMacro  7,14
monsDataMacro  8,14
monsDataMacro  9,14
monsDataMacro 11,14

; 5
monsDataMacro  6,15
monsDataMacro  7,15
monsDataMacro  8,15
monsDataMacro  9,15
monsDataMacro 11,15
; 6
monsDataMacro  6,16
monsDataMacro  7,16
monsDataMacro  8,16
monsDataMacro  9,16
monsDataMacro 10,16
monsDataMacro 11,16

; 7
monsDataMacro  5,17
monsDataMacro  6,17
monsDataMacro  7,17
monsDataMacro  8,17
monsDataMacro  9,17
monsDataMacro 10,17
monsDataMacro 11,17








; EEEX^[ړAݍς̂ȁEEEB
; ǂlĂш摫ȁcB
;MONSACT00_00:
;.word MONSACT00_00_ADDR, MONSACT00_00_DATA
;
; VRAM  0x6000 word AhX炠ƂāA
; 1024p^[ 2bit/4-colorƂ
; 32x32=0x20 x 0x20 = 0x400 鎖ɂȂB
;MONSACT00_00_ADDR:		; 0x40 * y + x*2
;.word 0x40 * 0 + 2* 8, 0x40 * 0 + 2* 9, 0x40 * 0 + 2* 10
;.word 0x40 * 1 + 2* 7, 0x40 * 1 + 2*10
;.word 0x40 * 2 + 2* 7, 0x40 * 2 + 2* 8, 0x40 * 2 + 2*10
;.word 0x40 * 3 + 2* 8, 0x40 * 3 + 2* 9, 0x40 * 3 + 2*10
;.word 0x40 * 4 + 2* 5, 0x40 * 4 + 2* 6, 0x40 * 4 + 2* 7, 0x40 * 4 + 2* 8
;.word 0x40 * 4 + 2* 9, 0x40 * 4 + 2*10, 0x40 * 4 + 2*11, 0x40 * 4 + 2*12
;.word 0x40 * 4 + 2*13
;.word 0x40 * 5 + 2* 4, 0x40 * 5 + 2* 5, 0x40 * 5 + 2*13
;.word 0x40 * 6 + 2* 5, 0x40 * 6 + 2*12, 0x40 * 6 + 2*13
;.word 0x40 * 7 + 2* 5, 0x40 * 7 + 2*11, 0x40 * 7 + 2*13
;.word 0x40 * 8 + 2* 5, 0x40 * 8 + 2* 6, 0x40 * 8 + 2* 7, 0x40 * 8 + 2*10
;.word 0x40 * 8 + 2*10, 0x40 * 8 + 2*12
;.word 0x40 * 9 + 2* 5, 0x40 * 9 + 2* 6, 0x40 * 9 + 2* 7, 0x40 * 9 + 2*10
;.word 0x40 * 9 + 2*11, 0x40 * 9 + 2*13
;.word 0x40 *10 + 2* 5, 0x40 *10 + 2* 7, 0x40 *10 + 2*10, 0x40 *10 + 2*11
;.word 0x40 *10 + 2*13
;.word 0x40 *11 + 2* 5, 0x40 *11 + 2* 6, 0x40 *11 + 2* 7, 0x40 *11 + 2* 8
;.word 0x40 *11 + 2* 9, 0x40 *11 + 2*10, 0x40 *11 + 2*11, 0x40 *11 + 2*12
;.word 0x40 *11 + 2*13
;.word 0x40 *12 + 2* 5, 0x40 *12 + 2* 6, 0x40 *12 + 2* 7, 0x40 *12 + 2* 9
;.word 0x40 *12 + 2*11, 0x40 *12 + 2*12, 0x40 *12 + 2*13
;.word 0x40 *13 + 2* 7, 0x40 *13 + 2* 8, 0x40 *13 + 2* 9, 0x40 *13 + 2*10
;.word 0x40 *13 + 2*11
;.word 0x40 *14 + 2* 6, 0x40 *14 + 2* 7, 0x40 *14 + 2* 8, 0x40 *14 + 2* 9
;.word 0x40 *14 + 2*11
;.word 0x40 *15 + 2* 6, 0x40 *15 + 2* 7, 0x40 *15 + 2* 8, 0x40 *15 + 2* 9
;.word 0x40 *15 + 2*11
;.word 0x40 *16 + 2* 6, 0x40 *16 + 2* 7, 0x40 *16 + 2* 8, 0x40 *16 + 2* 9
;.word 0x40 *16 + 2*10, 0x40 *16 + 2*11
;.word 0x40 *17 + 2* 5, 0x40 *17 + 2* 6, 0x40 *17 + 2* 7, 0x40 *17 + 2* 8
;.word 0x40 *17 + 2* 9, 0x40 *17 + 2*10, 0x40 *17 + 2*11
;
;; Ƃ肠bitmapʂ̃^C}bvg
;MONSACT00_00_DATA:
;.word 32* 0 + 8, 32* 0 + 9, 32* 0 + 10
;.word 32* 1 + 7, 32* 1 + 10
;.word 32* 2 + 7, 32* 2 +  8, 32* 2 + 10
;.word 32* 3 + 8, 32* 3 +  9, 32* 3 + 10
;.word 32* 4 + 5, 32* 4 +  6, 32* 4 +  7, 32* 4 +  8
;.word 32* 4 + 9, 32* 4 + 10, 32* 4 + 11, 32* 4 + 12
;.word 32* 4 +13
;.word 32* 5 + 4, 32* 5 +  5, 32* 5 + 13
;.word 32* 6 + 5, 32* 6 + 12, 32* 6 + 13
;.word 32* 7 + 5, 32* 7 + 11, 32* 7 + 13
;.word 32* 8 + 5, 32* 8 +  6, 32* 8 +  7, 32* 8 + 10
;.word 32* 8 +10, 32* 8 + 12
;.word 32* 9 + 5, 32* 9 +  6, 32* 9 +  7, 32* 9 + 10
;.word 32* 9 +11, 32* 9 + 13
;.word 32*10 + 5, 32*10 +  7, 32*10 + 10, 32*10 + 11
;.word 32*10 +13
;.word 32*11 + 5, 32*11 +  6, 32*11 +  7, 32*11 +  8
;.word 32*11 + 9, 32*11 + 10, 32*11 + 11, 32*11 + 12
;.word 32*11 +13
;.word 32*12 + 5, 32*12 +  6, 32*12 +  7, 32*12 +  9
;.word 32*12 +11, 32*12 + 12, 32*12 + 13
;.word 32*13 + 7, 32*13 +  8, 32*13 +  9, 32*13 + 10
;.word 32*13 +11
;.word 32*14 + 6, 32*14 +  7, 32*14 +  8, 32*14 +  9
;.word 32*14 +11
;.word 32*15 + 6, 32*15 +  7, 32*15 +  8, 32*15 +  9
;.word 32*15 +11
;.word 32*16 + 6, 32*16 +  7, 32*16 +  8, 32*16 +  9
;.word 32*16 +10, 32*16 + 11
;.word 32*17 + 5, 32*17 +  6, 32*17 +  7, 32*17 +  8
;.word 32*17 + 9, 32*17 + 10, 32*17 + 11
;
;;Ƃ肠 2bit 4-color 
;;񈳏k
;
;
;
;
;
;
;

.endif


;

